diff --git a/src/main/java/net/minecraft/client/render/FlagRenderer.java b/src/main/java/net/minecraft/client/render/FlagRenderer.java
index c7cdb60f1..999c3cdc7 100644
--- a/src/main/java/net/minecraft/client/render/FlagRenderer.java
+++ b/src/main/java/net/minecraft/client/render/FlagRenderer.java
@@ -1,8 +1,7 @@
 package net.minecraft.client.render;
 
 import net.minecraft.client.GLAllocation;
-import net.minecraft.client.Minecraft;
-import net.minecraft.core.block.entity.FlagBlockEntity;
+import net.minecraft.core.block.entity.TileEntityFlag;
 import net.minecraft.core.item.Items;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.net.command.TextFormatting;
@@ -11,7 +10,6 @@ import org.jetbrains.annotations.NotNull;
 
 import java.util.ArrayList;
 import java.util.Arrays;
-import java.util.HashMap;
 import java.util.HashSet;
 import java.util.Hashtable;
 import java.util.Iterator;
@@ -27,7 +25,7 @@ public class FlagRenderer {
 
     private final List<Integer> freeTextures = new ArrayList<>();
     private final List<FlagTextureEntry> flagTextures = new ArrayList<>();
-    private final Map<FlagBlockEntity, FlagTextureEntry> cache = new Hashtable<>();
+    private final Map<TileEntityFlag, FlagTextureEntry> cache = new Hashtable<>();
     
     public FlagRenderer(TextureManager textureManager)
     {
@@ -39,15 +37,15 @@ public class FlagRenderer {
     public void tick() {
         tickCount++;
         if (tickCount % 100 != 0) return;
-        Iterator<Map.Entry<FlagBlockEntity, FlagTextureEntry>> iterator = cache.entrySet().iterator();
+        Iterator<Map.Entry<TileEntityFlag, FlagTextureEntry>> iterator = cache.entrySet().iterator();
         while (iterator.hasNext()) {
-            Map.Entry<FlagBlockEntity, FlagTextureEntry> e = iterator.next();
-            FlagBlockEntity flagBlockEntity = e.getKey();
-            if (flagBlockEntity.isInvalid()) {
+            Map.Entry<TileEntityFlag, FlagTextureEntry> e = iterator.next();
+            TileEntityFlag tileEntityFlag = e.getKey();
+            if (tileEntityFlag.isInvalid()) {
                 // Remove reference to flag from entry
                 FlagTextureEntry entry = e.getValue();
-                assert entry.appliedFlags.contains(flagBlockEntity);
-                entry.appliedFlags.remove(flagBlockEntity);
+                assert entry.appliedFlags.contains(tileEntityFlag);
+                entry.appliedFlags.remove(tileEntityFlag);
 
                 // If flag texture is no longer referenced by any flags then free its texture
                 if (entry.appliedFlags.isEmpty()) {
@@ -70,12 +68,12 @@ public class FlagRenderer {
     }
 
     
-    public int getTexture(FlagBlockEntity flagBlockEntity)
+    public int getTexture(TileEntityFlag tileEntityFlag)
     {
-        return getEntryForFlag(flagBlockEntity).texture;
+        return getEntryForFlag(tileEntityFlag).texture;
     }
 
-    private @NotNull FlagTextureEntry getEntryForFlag(FlagBlockEntity flag) {
+    private @NotNull FlagTextureEntry getEntryForFlag(TileEntityFlag flag) {
         // Returned cached value if not dirty
         if (!flag.isDirty) {
             FlagTextureEntry e = cache.get(flag);
@@ -123,7 +121,7 @@ public class FlagRenderer {
         return returnEntry;
     }
 
-    private int[] flagDataToRGB(FlagBlockEntity tileEntity, byte[] colorData)
+    private int[] flagDataToRGB(TileEntityFlag tileEntity, byte[] colorData)
     {
         int[] data = new int[CANVAS_WIDTH * CANVAS_HEIGHT];
 
@@ -144,7 +142,7 @@ public class FlagRenderer {
         return data;
     }
 
-    private int getColorMap(FlagBlockEntity tileEntity, int index)
+    private int getColorMap(TileEntityFlag tileEntity, int index)
     {
         int col = 0x00FFFFFF;
         if(index > 0 && index <= 3)
@@ -163,7 +161,7 @@ public class FlagRenderer {
         public final int activeDyes;
         public final byte[] colorData;
         public final int texture;
-        public final Set<FlagBlockEntity> appliedFlags = new HashSet<>();
+        public final Set<TileEntityFlag> appliedFlags = new HashSet<>();
 
         public FlagTextureEntry(int texture, int colorHash, int activeDyes, byte[] colorData) {
             this.texture = texture;
diff --git a/src/main/java/net/minecraft/client/render/FogManager.java b/src/main/java/net/minecraft/client/render/FogManager.java
index d081f6611..b0d8db120 100644
--- a/src/main/java/net/minecraft/client/render/FogManager.java
+++ b/src/main/java/net/minecraft/client/render/FogManager.java
@@ -9,8 +9,8 @@ import org.lwjgl.opengl.NVFogDistance;
 
 import net.minecraft.client.GLAllocation;
 import net.minecraft.client.Minecraft;
-import net.minecraft.client.gui.PhotoModeScreen;
-import net.minecraft.client.gui.modelviewer.ModelViewerScreen;
+import net.minecraft.client.gui.ScreenPhotoMode;
+import net.minecraft.client.gui.modelviewer.ScreenModelViewer;
 import net.minecraft.client.option.enums.RenderDistance;
 import net.minecraft.client.render.camera.CameraUtil;
 import net.minecraft.client.render.colorizer.Colorizers;
@@ -78,9 +78,9 @@ public class FogManager {
 
             if (fogDistance > maxFogDistance * fogModifier) fogDistance = maxFogDistance * fogModifier;
 
-            if (mc.currentScreen instanceof PhotoModeScreen)
+            if (mc.currentScreen instanceof ScreenPhotoMode)
             {
-                fogDistance = farPlaneDistance * ((PhotoModeScreen)mc.currentScreen).getFog(partialTick);
+                fogDistance = farPlaneDistance * ((ScreenPhotoMode)mc.currentScreen).getFog(partialTick);
             }
 
             glFogi(GL_FOG_MODE, GL_LINEAR);
@@ -170,8 +170,8 @@ public class FogManager {
         fogRed *= brightness;
         fogGreen *= brightness;
         fogBlue *= brightness;
-        if (mc.currentScreen instanceof ModelViewerScreen) {
-            float[] color = ((ModelViewerScreen) mc.currentScreen).getBackgroundFogColor();
+        if (mc.currentScreen instanceof ScreenModelViewer) {
+            float[] color = ((ScreenModelViewer) mc.currentScreen).getBackgroundFogColor();
             fogRed = color[0];
             fogGreen = color[1];
             fogBlue = color[2];
diff --git a/src/main/java/net/minecraft/client/render/ItemRenderer.java b/src/main/java/net/minecraft/client/render/ItemRenderer.java
index 7dd27c1e0..bc65e5e3b 100644
--- a/src/main/java/net/minecraft/client/render/ItemRenderer.java
+++ b/src/main/java/net/minecraft/client/render/ItemRenderer.java
@@ -1,16 +1,16 @@
 package net.minecraft.client.render;
 
-import net.minecraft.client.entity.player.LocalPlayer;
+import net.minecraft.client.entity.player.PlayerLocal;
 import net.minecraft.client.render.block.color.BlockColorDispatcher;
 import net.minecraft.core.item.Item;
-import net.minecraft.core.item.block.BlockItem;
+import net.minecraft.core.item.block.ItemBlock;
 import org.lwjgl.opengl.GL11;
 
 import net.minecraft.client.Minecraft;
 import net.minecraft.client.render.block.model.BlockModel;
 import net.minecraft.client.render.block.model.BlockModelDispatcher;
 import net.minecraft.client.render.entity.EntityRenderer;
-import net.minecraft.client.render.entity.PlayerRenderer;
+import net.minecraft.client.render.entity.MobRendererPlayer;
 import net.minecraft.client.render.item.model.ItemModelDispatcher;
 import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import net.minecraft.client.render.texture.stitcher.TextureRegistry;
@@ -36,8 +36,8 @@ import static org.lwjgl.opengl.GL11.glPushMatrix;
 //            RenderBlocks, MapItemRenderer, ItemStack, Block, 
 //            RenderEngine, Mob, Tessellator, Player,
 //            RenderHelper, MathHelper, World, Item, 
-//            MapItem, LocalPlayer, RenderManager, RenderPlayer,
-//            Material, FireBlock, InventoryPlayer
+//            ItemMap, PlayerLocal, RenderManager, RenderPlayer,
+//            Material, BlockFire, InventoryPlayer
 
 public class ItemRenderer
 {
@@ -56,8 +56,8 @@ public class ItemRenderer
     }
 
     public int getItemColorFromMetadata(Item item, int metadata) {
-        if (item instanceof BlockItem) {
-            Block block = ((BlockItem)item).getBlock();
+        if (item instanceof ItemBlock) {
+            Block block = ((ItemBlock)item).getBlock();
             return BlockColorDispatcher.getInstance().getDispatch(block).getFallbackColor(metadata);
         }
         return 0xFFFFFF;
@@ -66,7 +66,7 @@ public class ItemRenderer
     public void renderItemInFirstPerson(float partialTick)
     {
         float equipProgress = getEquippedProgress(partialTick);
-        LocalPlayer player = mc.thePlayer;
+        PlayerLocal player = mc.thePlayer;
         float rotationPitch = player.xRotO + (player.xRot - player.xRotO) * partialTick;
         GL11.glPushMatrix();
         GL11.glRotatef(rotationPitch, 1.0F, 0.0F, 0.0F);
@@ -90,7 +90,7 @@ public class ItemRenderer
         	}
             GL11.glColor4f(brightness, brightness, brightness, 1.0f);
             EntityRenderer<? extends Entity> render = EntityRenderDispatcher.instance.getRenderer(mc.thePlayer);
-            PlayerRenderer playerRenderer = (PlayerRenderer)render;
+            MobRendererPlayer playerRenderer = (MobRendererPlayer)render;
             if (player.getHeldObject() == null) {
                 float f6 = 0.8F;
                 float swingProgress = player.getSwingProgress(partialTick);
@@ -281,7 +281,7 @@ public class ItemRenderer
     public void updateEquippedItem()
     {
         oHeight = height;
-        LocalPlayer entityplayersp = mc.thePlayer;
+        PlayerLocal entityplayersp = mc.thePlayer;
         ItemStack itemstack = entityplayersp.inventory.getCurrentItem();
         boolean flag = lastSlot == entityplayersp.inventory.getCurrentItemIndex() && itemstack == itemToRender;
         if(itemToRender == null && itemstack == null)
diff --git a/src/main/java/net/minecraft/client/render/LightmapHelper.java b/src/main/java/net/minecraft/client/render/LightmapHelper.java
index 55fc7dcf6..2b529a91b 100644
--- a/src/main/java/net/minecraft/client/render/LightmapHelper.java
+++ b/src/main/java/net/minecraft/client/render/LightmapHelper.java
@@ -10,7 +10,7 @@ import java.util.Arrays;
 import com.mojang.logging.LogUtils;
 import net.minecraft.client.GLAllocation;
 import net.minecraft.client.Minecraft;
-import net.minecraft.client.gui.PhotoModeScreen;
+import net.minecraft.client.gui.ScreenPhotoMode;
 import net.minecraft.client.option.enums.LightmapStyle;
 import net.minecraft.client.util.helper.Textures;
 import net.minecraft.core.util.helper.Buffer;
@@ -169,7 +169,7 @@ public class LightmapHelper {
 			
 			if(smooth) {
 				float skyDarken = prevSkyDarken + (skyDarkenSmooth - prevSkyDarken) * partialTicks;
-				if(mc.currentScreen instanceof PhotoModeScreen) {
+				if(mc.currentScreen instanceof ScreenPhotoMode) {
 					skyDarken = world.skyDarken;
 				}
 				float modifiedSkylight = Math.max(0, skyLightLevel - skyDarken);
diff --git a/src/main/java/net/minecraft/client/render/MapItemRenderer.java b/src/main/java/net/minecraft/client/render/MapItemRenderer.java
index bfe12dd81..5caa559c1 100644
--- a/src/main/java/net/minecraft/client/render/MapItemRenderer.java
+++ b/src/main/java/net/minecraft/client/render/MapItemRenderer.java
@@ -3,7 +3,7 @@ package net.minecraft.client.render;
 import java.awt.image.BufferedImage;
 import java.util.Iterator;
 
-import net.minecraft.client.render.texture.BufferedTexture;
+import net.minecraft.client.render.texture.TextureBuffered;
 
 import net.minecraft.client.option.GameSettings;
 import net.minecraft.client.render.tessellator.Tessellator;
@@ -182,7 +182,7 @@ public class MapItemRenderer
     }
 
     private final int[] mapImageData;
-    private final BufferedTexture mapTexture;
+    private final TextureBuffered mapTexture;
     private final GameSettings gameSettings;
     private Font font;
 }
diff --git a/src/main/java/net/minecraft/client/render/ParticleEngine.java b/src/main/java/net/minecraft/client/render/ParticleEngine.java
index 94ddc68ca..13e593105 100644
--- a/src/main/java/net/minecraft/client/render/ParticleEngine.java
+++ b/src/main/java/net/minecraft/client/render/ParticleEngine.java
@@ -3,7 +3,7 @@ package net.minecraft.client.render;
 import java.util.*;
 
 import net.minecraft.client.render.camera.ICamera;
-import net.minecraft.client.entity.particle.TerrainParticle;
+import net.minecraft.client.entity.particle.ParticleBlockBreaking;
 import net.minecraft.client.entity.particle.Particle;
 import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.client.render.tessellator.Tessellator;
@@ -165,7 +165,7 @@ public final class ParticleEngine {
                     double yp = y + (yy + 0.5D) / amount;
                     double zp = z + (zz + 0.5D) / amount;
                     Side side = Side.getSideById(rand.nextInt(6));
-                    add((new TerrainParticle(world, xp, yp, zp, xp - x - 0.5D, yp - y - 0.5D, zp - z - 0.5D, block, side, data)).init(x, y, z));
+                    add((new ParticleBlockBreaking(world, xp, yp, zp, xp - x - 0.5D, yp - y - 0.5D, zp - z - 0.5D, block, side, data)).init(x, y, z));
                 }
             }
         }
@@ -201,7 +201,7 @@ public final class ParticleEngine {
         } else if (side == Side.EAST) {
             xp = x + block.maxX + r;
         }
-        add((new TerrainParticle(world, xp, yp, zp, 0.0D, 0.0D, 0.0D, block, side, world.getBlockMetadata(x, y, z))).init(x, y, z).setPower(0.2F).setScale(0.6F));
+        add((new ParticleBlockBreaking(world, xp, yp, zp, 0.0D, 0.0D, 0.0D, block, side, world.getBlockMetadata(x, y, z))).init(x, y, z).setPower(0.2F).setScale(0.6F));
     }
 
     public int countParticles() {
diff --git a/src/main/java/net/minecraft/client/render/Polygon.java b/src/main/java/net/minecraft/client/render/Polygon.java
index 9844c9768..480f80e3a 100644
--- a/src/main/java/net/minecraft/client/render/Polygon.java
+++ b/src/main/java/net/minecraft/client/render/Polygon.java
@@ -28,6 +28,17 @@ public class Polygon
         vertices[3] = vertices[3].remap((float)maxU / texWidth - offsetU, (float)maxV / texHeight - offsetV);
     }
 
+    public void mirror()
+    {
+        Vertex[] vertices = new Vertex[this.vertices.length];
+        for(int i = 0; i < this.vertices.length; i++)
+        {
+            vertices[i] = this.vertices[this.vertices.length - i - 1];
+        }
+
+        this.vertices = vertices;
+    }
+
     public void mirrorU()
     {
         float minU = vertices[1].u;
diff --git a/src/main/java/net/minecraft/client/render/RenderBlocks.java b/src/main/java/net/minecraft/client/render/RenderBlocks.java
index c6e406798..6fdbcacaa 100644
--- a/src/main/java/net/minecraft/client/render/RenderBlocks.java
+++ b/src/main/java/net/minecraft/client/render/RenderBlocks.java
@@ -13,11 +13,11 @@ import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.WorldSource;
 
 // Referenced classes of package net.minecraft.src:
-//            Block, RailBlock, Tessellator, IBlockAccess,
-//            BedBlock, ModelBed, RepeaterBlock, PistonBaseBlock,
-//            BlockPistonExtension, Vec3D, FireBlock, RedstoneWireBlock,
-//            EntityRenderer, FluidBlock, MathHelper, Material,
-//            DoorBlock, World
+//            Block, BlockRail, Tessellator, IBlockAccess,
+//            BlockBed, ModelBed, BlockRepeater, BlockPistonBase,
+//            BlockPistonExtension, Vec3D, BlockFire, BlockWireRedstone,
+//            EntityRenderer, BlockFluid, MathHelper, Material,
+//            BlockDoor, World
 
 public class RenderBlocks
 {
diff --git a/src/main/java/net/minecraft/client/render/RenderGlobal.java b/src/main/java/net/minecraft/client/render/RenderGlobal.java
index b11dcc35d..c4904019e 100644
--- a/src/main/java/net/minecraft/client/render/RenderGlobal.java
+++ b/src/main/java/net/minecraft/client/render/RenderGlobal.java
@@ -4,11 +4,11 @@ import net.minecraft.client.GLAllocation;
 import net.minecraft.client.Minecraft;
 import net.minecraft.client.entity.particle.Particle;
 import net.minecraft.client.entity.particle.ParticleDispatcher;
-import net.minecraft.client.gui.PhotoModeScreen;
-import net.minecraft.client.gui.modelviewer.ModelViewerScreen;
+import net.minecraft.client.gui.ScreenPhotoMode;
+import net.minecraft.client.gui.modelviewer.ScreenModelViewer;
 import net.minecraft.client.render.block.model.BlockModel;
 import net.minecraft.client.render.block.model.BlockModelDispatcher;
-import net.minecraft.client.render.block.model.LeavesBlockModel;
+import net.minecraft.client.render.block.model.BlockModelLeaves;
 import net.minecraft.client.render.camera.EntityCamera;
 import net.minecraft.client.render.camera.ICamera;
 import net.minecraft.client.render.colorizer.Colorizers;
@@ -17,9 +17,9 @@ import net.minecraft.client.render.terrain.ChunkRenderer;
 import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.client.render.tessellator.Tessellator;
-import net.minecraft.core.block.entity.BlockEntity;
+import net.minecraft.core.block.entity.TileEntity;
 import net.minecraft.core.entity.player.Player;
-import net.minecraft.core.item.MusicDiscItem;
+import net.minecraft.core.item.ItemDiscMusic;
 import net.minecraft.core.lang.I18n;
 import net.minecraft.core.util.helper.Color;
 import net.minecraft.core.util.helper.Direction;
@@ -44,7 +44,6 @@ import net.minecraft.core.world.weather.Weathers;
 import org.lwjgl.opengl.ARBOcclusionQuery;
 import org.lwjgl.opengl.GL11;
 import org.lwjgl.opengl.GL15;
-import org.useless.stellar.StarUtil;
 
 import java.nio.IntBuffer;
 import java.util.ArrayList;
@@ -58,8 +57,8 @@ import static org.lwjgl.opengl.GL11.*;
 //            IWorldAccess, GLAllocation, RenderList, OpenGlCapsChecker, 
 //            Tessellator, World, RenderManager, RenderBlocks,
 //            Block, GameSettings, BlockLeaves, WorldRenderer, 
-//            Entity, MathHelper, EntitySorter, BlockEntityRenderer,
-//            ICamera, Mob, BlockEntity, RenderHelper,
+//            Entity, MathHelper, EntitySorter, TileEntityRenderer,
+//            ICamera, Mob, TileEntity, RenderHelper,
 //            EntityRenderer, WorldProvider, Vec3D, RenderEngine, 
 //            RenderSorter, MovingObjectPosition, Player, EnumMovingObjectType,
 //            AxisAlignedBB, GuiIngame, SoundEngine, EntityBubbleFX,
@@ -67,7 +66,7 @@ import static org.lwjgl.opengl.GL11.*;
 //            EntityExplodeFX, EntityFlameFX, EntityLavaFX, EntityFootStepFX, 
 //            EntitySplashFX, EntityReddustFX, EntityItemFX, Item,
 //            EntitySnowShovelFX, EntityHeartFX, ImageBufferDownload, StepSound, 
-//            MusicDiscItem, ItemStack
+//            ItemDiscMusic, ItemStack
 
 public class RenderGlobal
     implements LevelListener
@@ -166,9 +165,9 @@ public class RenderGlobal
             d *= d4;
             d1 *= d4;
             d2 *= d4;
-            double d5 = d * 100D;
-            double d6 = d1 * 100D;
-            double d7 = d2 * 100D;
+            double x = d * 100D;
+            double y = d1 * 100D;
+            double z = d2 * 100D;
             double d8 = java.lang.Math.atan2(d, d2);
             double d9 = java.lang.Math.sin(d8);
             double d10 = java.lang.Math.cos(d8);
@@ -179,24 +178,20 @@ public class RenderGlobal
             double d15 = java.lang.Math.sin(d14);
             double d16 = java.lang.Math.cos(d14);
 
-            int starColor = Colorizers.stars.getDefaultColor(colorRandom.nextDouble(), 1); /*StarUtil.getStarColorFromTemp(1000 + colorRandom.nextInt(17500));*/
-            tessellator.setColorOpaque(Color.redFromInt(starColor)/4 + 32, Color.greenFromInt(starColor)/4 + 32, Color.blueFromInt(starColor)/4 + 32);
-
+            double color = colorRandom.nextDouble();
             for(int j = 0; j < 4; j++)
             {
                 double d17 = 0.0D;
                 double d18 = (double)((j & 2) - 1) * d3;
                 double d19 = (double)((j + 1 & 2) - 1) * d3;
-                double d20 = d17;
                 double d21 = d18 * d16 - d19 * d15;
                 double d22 = d19 * d16 + d18 * d15;
-                double d23 = d22;
-                double d24 = d21 * d12 + d20 * d13;
-                double d25 = d20 * d12 - d21 * d13;
-                double d26 = d25 * d9 - d23 * d10;
-                double d27 = d24;
-                double d28 = d23 * d9 + d25 * d10;
-                tessellator.addVertex(d5 + d26, d6 + d27, d7 + d28);
+                double yOff = d21 * d12 + d17 * d13;
+                double d25 = d17 * d12 - d21 * d13;
+                double xOff = d25 * d9 - d22 * d10;
+                double zOff = d22 * d9 + d25 * d10;
+
+                tessellator.addVertexWithUV(x + xOff, y + yOff, z + zOff, color, 0);
             }
 
         }
@@ -233,7 +228,7 @@ public class RenderGlobal
         deleteRenderListBase();
         glRenderListBase = GLAllocation.generateDisplayLists(RENDER_LIST_BASE_WIDTH * RENDER_LIST_BASE_WIDTH * RENDER_LIST_BASE_WIDTH * 3);
 
-        LeavesBlockModel.setGraphicsLevel(mc.gameSettings.fancyGraphics.value == 1);
+        BlockModelLeaves.setGraphicsLevel(mc.gameSettings.fancyGraphics.value == 1);
         renderDistance = mc.gameSettings.renderDistance.value;
         if (worldObj == null) return;
 
@@ -481,9 +476,9 @@ public class RenderGlobal
             }
         }
 
-        for (BlockEntity blockEntity : tileEntities)
+        for (TileEntity tileEntity : tileEntities)
         {
-            BlockEntityRenderDispatcher.instance.renderTileEntity(tessellator, blockEntity, partialTick);
+            BlockEntityRenderDispatcher.instance.renderTileEntity(tessellator, tileEntity, partialTick);
         }
     }
 
@@ -831,7 +826,7 @@ public class RenderGlobal
 
     public void drawSky(float partialTick)
     {
-        if(!mc.theWorld.getWorldType().hasSky() || mc.currentScreen instanceof ModelViewerScreen)
+        if(!mc.theWorld.getWorldType().hasSky() || mc.currentScreen instanceof ScreenModelViewer)
         {
             return;
         }
@@ -992,14 +987,15 @@ public class RenderGlobal
         t.addVertexWithUV(-size, -100D, -size, 1.0D, 0.0D);
         t.draw();
 
-        GL11.glDisable(GL11.GL_TEXTURE_2D);
         float f17 = worldObj.getStarBrightness(partialTick) * sunAlpha;
         if(f17 > 0.0F)
         {
+            textureManager.loadTexture("/assets/minecraft/textures/colormap/stars/default.png").bind();
             GL11.glColor4f(f17, f17, f17, f17);
             GL11.glCallList(starGLCallList);
         }
         GL11.glColor4f(1.0F, 1.0F, 1.0F, 1.0F);
+        GL11.glDisable(GL11.GL_TEXTURE_2D);
         GL11.glDisable(GL11.GL_BLEND);
         GL11.glEnable(GL11.GL_ALPHA_TEST);
         GL11.glEnable(GL11.GL_FOG);
@@ -1025,7 +1021,7 @@ public class RenderGlobal
         {
             return;
         }
-        if (mc.currentScreen instanceof PhotoModeScreen)
+        if (mc.currentScreen instanceof ScreenPhotoMode)
         {
             return;
         }
@@ -1353,7 +1349,7 @@ public class RenderGlobal
 
     public void drawSelectionBox(ICamera camera, HitResult hitResult, float partialTick)
     {
-        if (mc.gameSettings.immersiveMode.drawOutline() && mc.gameSettings.blockOutlineWidth.value > 0.01f && !(mc.currentScreen instanceof ModelViewerScreen))
+        if (mc.gameSettings.immersiveMode.drawOutline() && mc.gameSettings.blockOutlineWidth.value > 0.01f && !(mc.currentScreen instanceof ScreenModelViewer))
         {
             GL11.glEnable(GL11.GL_BLEND);
             GL11.glBlendFunc(GL11.GL_SRC_ALPHA, GL11.GL_ONE_MINUS_SRC_ALPHA);
@@ -1642,9 +1638,9 @@ public class RenderGlobal
         if(soundPath != null)
         {
             if (author != null && !author.isEmpty()){
-                mc.ingameHud.setRecordPlayingMessage(author + " - " + I18n.getInstance().translateKey(soundPath));
+                mc.hudIngame.setRecordPlayingMessage(author + " - " + I18n.getInstance().translateKey(soundPath));
             } else {
-                mc.ingameHud.setRecordPlayingMessage(I18n.getInstance().translateKey(soundPath));
+                mc.hudIngame.setRecordPlayingMessage(I18n.getInstance().translateKey(soundPath));
             }
         }
         mc.sndManager.playMusic(soundPath, x, y, z, 1.0F, 1.0F);
@@ -1699,7 +1695,7 @@ public class RenderGlobal
 	}
 
     @Override
-    public void tileEntityChanged(int x, int y, int z, BlockEntity blockEntity)
+    public void tileEntityChanged(int x, int y, int z, TileEntity tileEntity)
     {
     }
 
@@ -1772,8 +1768,8 @@ public class RenderGlobal
                 break;
 
             case EVENT_JUKEBOX_TOGGLE: // Jukebox play/stop record
-                if(Item.itemsList[data] instanceof MusicDiscItem) {
-                    MusicDiscItem record = ((MusicDiscItem)Item.itemsList[data]);
+                if(Item.itemsList[data] instanceof ItemDiscMusic) {
+                    ItemDiscMusic record = ((ItemDiscMusic)Item.itemsList[data]);
                     worldObj.playRecord(record.recordName, record.recordAuthor, x, y, z);
                 } else {
                     worldObj.playRecord(null, null, x, y, z);
@@ -1796,7 +1792,7 @@ public class RenderGlobal
 	public void entityRemoved(Entity entity) {
 	}
 
-    public List<BlockEntity> tileEntities;
+    public List<TileEntity> tileEntities;
     private World worldObj;
     private final TextureManager textureManager;
     private final List<ChunkRenderer> chunkRenderersToUpdate;
diff --git a/src/main/java/net/minecraft/client/render/TextureManager.java b/src/main/java/net/minecraft/client/render/TextureManager.java
index 7264eec72..14b266f0b 100644
--- a/src/main/java/net/minecraft/client/render/TextureManager.java
+++ b/src/main/java/net/minecraft/client/render/TextureManager.java
@@ -30,7 +30,6 @@ import net.minecraft.client.render.dynamictexture.DynamicTextureFire;
 import net.minecraft.client.render.dynamictexture.DynamicTextureFireflyJar;
 import net.minecraft.client.render.dynamictexture.DynamicTextureLavaFlowing;
 import net.minecraft.client.render.dynamictexture.DynamicTextureLavaStill;
-import net.minecraft.client.render.dynamictexture.DynamicTexturePortal;
 import net.minecraft.client.render.dynamictexture.DynamicTextureTrommel;
 import net.minecraft.client.render.dynamictexture.DynamicTextureWaterFlow;
 import net.minecraft.client.render.dynamictexture.DynamicTextureWaterStill;
@@ -38,9 +37,9 @@ import net.minecraft.client.render.texture.meta.AnimationProperties;
 import net.minecraft.client.render.texture.stitcher.AtlasStitcher;
 import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import net.minecraft.client.render.texture.stitcher.TextureRegistry;
-import net.minecraft.client.render.texture.BufferedTexture;
-import net.minecraft.client.render.texture.DownloadedTexture;
-import net.minecraft.client.render.texture.FileTexture;
+import net.minecraft.client.render.texture.TextureBuffered;
+import net.minecraft.client.render.texture.TextureDownloaded;
+import net.minecraft.client.render.texture.TextureFile;
 import net.minecraft.client.render.texture.Texture;
 import net.minecraft.client.render.texturepack.TexturePackException;
 import net.minecraft.client.render.texturepack.TexturePackList;
@@ -60,8 +59,8 @@ public class TextureManager {
 
 	public final Map<Integer, Texture> idToTextureMap = new HashMap<>();
 	public final Map<String, Texture> textureMap = new HashMap<>();
-	public final List<BufferedTexture> bufferedTextures = new ArrayList<>();
-	public final Map<String, DownloadedTexture> downloadedTextures = new HashMap<>();
+	public final List<TextureBuffered> bufferedTextures = new ArrayList<>();
+	public final Map<String, TextureDownloaded> downloadedTextures = new HashMap<>();
 	public final Map<NamespaceID, DynamicTexture> dynamicTextures = new HashMap<>();
 	
 	private final GameSettings gameSettings;
@@ -144,7 +143,7 @@ public class TextureManager {
 		Texture t = loadTextureNoDefault(name);
 		
 		if (t == null) {
-			t = new BufferedTexture(missingTexture, false, false, false);
+			t = new TextureBuffered(missingTexture, false, false, false);
 			textureMap.put(name, t);
 			idToTextureMap.put(t.id(), t);
         }
@@ -158,7 +157,7 @@ public class TextureManager {
 		if (texture != null) return texture;
 
 		try {
-			texture = new FileTexture(name);
+			texture = new TextureFile(name);
 			textureMap.put(name, texture);
 			idToTextureMap.put(texture.id(), texture);
 			return texture;
@@ -168,8 +167,8 @@ public class TextureManager {
 		return null;
 	}
 
-	public BufferedTexture loadBufferedTexture(BufferedImage bufferedimage) { // TODO, this may need a way to reduce textures from the same BufferedImage, since this allocates a new texture to memory every time its called
-		BufferedTexture texture = new BufferedTexture(bufferedimage, false, false, false);
+	public TextureBuffered loadBufferedTexture(BufferedImage bufferedimage) { // TODO, this may need a way to reduce textures from the same BufferedImage, since this allocates a new texture to memory every time its called
+		TextureBuffered texture = new TextureBuffered(bufferedimage, false, false, false);
 		bufferedTextures.add(texture);
 		return texture;
 	}
@@ -311,7 +310,7 @@ public class TextureManager {
         		String[] lines = string.split("\n");
 
                 for (String line : lines) {
-                    mc.ingameHud.addChatMessage(line);
+                    mc.hudIngame.addChatMessage(line);
                 }
         	}
         }
@@ -378,7 +377,7 @@ public class TextureManager {
             dynamicTexture.postInit();
         }
 
-		for (BufferedTexture t : bufferedTextures) {
+		for (TextureBuffered t : bufferedTextures) {
 			t.init();
 		}
 		for (Texture t : textureMap.values()) {
@@ -417,9 +416,9 @@ public class TextureManager {
 				return false;
 			}
 		}
-		DownloadedTexture texture = downloadedTextures.get(urlTexture);
+		TextureDownloaded texture = downloadedTextures.get(urlTexture);
 		if(texture == null) {
-			texture = new DownloadedTexture(urlTexture, imageParser);
+			texture = new TextureDownloaded(urlTexture, imageParser);
 			downloadedTextures.put(urlTexture, texture);
 		}
 		if(!texture.isGenerated()) {
